/**
 * December 2000 Dongwook Shin
 * An application handling NASA ADC dataset available at
 * http://xml.gsfc.nasa.gov/guides/
 * You can modify it to fit in your data with the following changes
 *  (1) at line 78 : XSLTInputSource xslSource = new XSLTInputSource("C:\\shin\\xmlfiles\\nasa\\adc.xsl");
 *       change the sample XSL file into your own XSL file
 *  (2) at line 349:   xr.initialize("\\shin\\xmlfiles\\nasa\\adcorg");
 *       change the sample nasa directory into the file (or directory) name where your XML data resides
 *  (3) Modifies jLabel7 to jLabel11 and jTextField1 to jTextField5 so that they represent some of elements in your data
 *  (4) at line 434:  'void jButton2_actionPerformed(ActionEvent e);'
 *       modify the function so that it can compose XPath query appropriately
 *  (5) Add the jar files for Xalan, Xerces, Swing and Xpert in your classpath as in:
 *       set classpath=.;C:\JBUILDER3\JAVA\LIB;C:\shin\xmlsystem\xalan_1_0_0\xerces.jar;C:\shin\XMLsystem\xerces-1_1_0\xerces.jar;C:\jbuilder3\myclasses\xpert.jar;C:\programfiles\swing-1.1\swing.jar;C:\shin\xmlsystem\xalan_1_0_0\xalan.jar;
 *       But, note that xalan\xerces.jar should precede xerces\xerces.jar
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.futurexpert.xpert.xretrieve.*;
import com.futurexpert.xpert.xutility.*;
import org.apache.xalan.xslt.*;
import org.apache.xalan.xslt.client.*;
import org.apache.xml.serialize.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class Frame2 extends JFrame {
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  // Dec 22 2000
  // Change into GridBag layout
  GridBagLayout gridLayout1 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  JButton jButton4 = new JButton();
  JScrollPane scrollPane = new JScrollPane();
  DataOutputStream dos = null;
  Xretrieve xr = null;
  Vector result = null;
  DefaultListModel listContent = new DefaultListModel();
  final JList jList1 = new JList(listContent);

  /**
   * When an element in the retrieved list is double-clicked,
   * first read the content of the element and save it into an XML file,
   * result.xml.
   * Secondly using the XSL file saved in a specific location,
   * create the corresponding HTML string, with displaying it in an EditorPane
   */
  MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
         if (e.getClickCount() == 2) {
              int index = jList1.locationToIndex(e.getPoint());
              try {
              dos = new DataOutputStream( new FileOutputStream("result.xml"));
              // System.out.println("index clicked = " + index);
              ElementInfo ei = (ElementInfo) result.elementAt(index);
              String content = xr.getElement(ei);
               System.out.println(content);
              dos.writeBytes("<xml_output>\n");
              dos.writeBytes(content);
              dos.writeBytes("\n");
               dos.writeBytes("</xml_output>\n");
               dos.close();
              XSLTProcessor xp = XSLTProcessorFactory.getProcessor();
              XSLTInputSource xmlSource = new XSLTInputSource("result.xml");
              // Locate the XSL file here!
              XSLTInputSource xslSource = new XSLTInputSource("C:\\shin\\xmlfiles\\nasa\\adc.xsl");
              org.apache.xerces.dom.DocumentImpl node = new org.apache.xerces.dom.DocumentImpl();
              XSLTResultTarget xt = new XSLTResultTarget(node);
              // xt.setNode(node);
              if((xp != null) && (xmlSource != null) && (xslSource != null) && (xt != null))
                xp.process(xmlSource, xslSource, xt); // process XSLT
              else System.out.println("One of the input is null.\n");

              ByteArrayOutputStream bao=new ByteArrayOutputStream();
              XMLSerializer s = new XMLSerializer();
              s.setOutputByteStream(bao);
              // s.setOutputFormat(bao);
              s.serialize(node);                // node is xml document
              JEditorPane jep = new JEditorPane("text/html", bao.toString());
              jep.setEditable(false);
      
              JScrollPane scrollPane = new JScrollPane(jep);
              JFrame f = new JFrame("HTML output");
              f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
              f.getContentPane().add(scrollPane);
              f.setSize(400, 400);
              f.show();
              }
              catch(com.futurexpert.xpert.xutility.XQueryException qe)
                  { System.out.println(qe); }
              catch(Exception ge) {System.out.println(ge); }
          }
     }
 };
  JLabel jLabel3 = new JLabel();
  JComboBox jComboBox1 = new JComboBox();
  JLabel jLabel2 = new JLabel();
  Component component1;
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JLabel jLabel12 = new JLabel();
  JLabel jLabel13 = new JLabel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JTextField jTextField1 = new JTextField();
  JTextField jTextField2 = new JTextField();
  JTextField jTextField3 = new JTextField();
  JTextField jTextField4 = new JTextField();
  JTextField jTextField5 = new JTextField();
  JTextField jTextField6 = new JTextField();

  //Construct the frame
  public Frame2() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    component1 = Box.createHorizontalStrut(8);
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(550, 650));
    this.setTitle("Nasa ADC Application");
    statusBar.setText(" ");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    jPanel1.setForeground(Color.white);
    jPanel1.setLayout(gridLayout1);
    jLabel1.setForeground(Color.blue);
    jLabel1.setBorder(BorderFactory.createEtchedBorder());
    jLabel1.setText("  XPath query");
    jButton4.setBackground(Color.yellow);
    jButton4.setText("Submit");
    jButton4.addActionListener(new Frame2_jButton4_actionAdapter(this));
    jList1.setVisibleRowCount(10);
    jLabel2.setForeground(Color.blue);
    jLabel2.setText("       ");
    jLabel3.setForeground(Color.blue);
    jLabel3.setBorder(BorderFactory.createEtchedBorder());
    jLabel3.setText("Score         Element Information");
    scrollPane.getViewport().setBackground(Color.white);
    jComboBox1.setToolTipText("");
    jLabel4.setBackground(Color.black);
    jLabel4.setBorder(BorderFactory.createEtchedBorder());
    jLabel5.setBackground(Color.black);
    jLabel6.setForeground(Color.blue);
    jLabel6.setBorder(BorderFactory.createEtchedBorder());
    jLabel6.setText("  Form-based query");
    jLabel7.setBorder(BorderFactory.createEtchedBorder());
    jLabel7.setText("author");
    jLabel8.setBorder(BorderFactory.createEtchedBorder());
    jLabel8.setText("keyword");
    jLabel9.setBorder(BorderFactory.createEtchedBorder());
    jLabel9.setText("date");
    jLabel10.setBorder(BorderFactory.createEtchedBorder());
    jLabel10.setText("para");
    jLabel11.setBorder(BorderFactory.createEtchedBorder());
    jLabel11.setText("title");
    jLabel12.setBorder(BorderFactory.createEtchedBorder());
    jLabel12.setText("Result query");
    jLabel13.setText(" ");
    jButton1.setBackground(Color.yellow);
    jButton1.setText("Submit");
    jButton1.addActionListener(new Frame2_jButton1_actionAdapter(this));
    jButton2.setBackground(Color.yellow);
    jButton2.setText("query compose");
    jButton2.addActionListener(new Frame2_jButton2_actionAdapter(this));
    jTextField1.setBorder(BorderFactory.createEtchedBorder());
    jTextField1.setText("star");
    jTextField2.setText("Jackson");
    jTextField3.setText("");
    jTextField4.setText("");
    jTextField5.setText("");
    jTextField6.setText("/dataset[contains(.//title,\"star\")]");
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);
    this.getContentPane().add(component1, BorderLayout.NORTH);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);

      // For label "XPath query"
      GridBagConstraints c1 = new GridBagConstraints();
      c1.anchor = GridBagConstraints.NORTHWEST;
      c1.gridwidth = GridBagConstraints.RELATIVE;
      c1.fill = GridBagConstraints.BOTH;
      jPanel1.add(jLabel1, c1);

      // For input combobox
      c1.fill = GridBagConstraints.HORIZONTAL;
      c1.gridwidth = GridBagConstraints.REMAINDER;
      jPanel1.add(jComboBox1, c1);

      // For query submit button
      c1.fill = GridBagConstraints.NONE;
      c1.gridwidth =  GridBagConstraints.REMAINDER;
      jPanel1.add(jButton4, c1);

      // For the null label ""
      c1.gridwidth =  GridBagConstraints.REMAINDER;
      c1.fill = GridBagConstraints.BOTH;
      jPanel1.add(jLabel13, c1);

      // For the label "Form-based query"
      GridBagConstraints c2 = new GridBagConstraints();
      c2.fill = GridBagConstraints.BOTH;
      c2.gridwidth = GridBagConstraints.REMAINDER;
      jPanel1.add(jLabel6, c2);

      // For the label "title"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel11, c2);

      // For the title text field
      GridBagConstraints c6 = new GridBagConstraints();
      c6.gridwidth =  GridBagConstraints.REMAINDER;
      c6.fill =  GridBagConstraints.BOTH;
      jPanel1.add(jTextField1, c6);

      // For the label "author"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel7, c2);

      // For author text field
      GridBagConstraints c7 = new GridBagConstraints();
      c7.gridwidth =  GridBagConstraints.REMAINDER;
      c7.fill =  GridBagConstraints.BOTH;
      jPanel1.add(jTextField2, c7);

      // For the label "keyword"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel8, c2);

      // For keyword text field
      GridBagConstraints c8 = new GridBagConstraints();
      c8.gridwidth =  GridBagConstraints.REMAINDER;
      c8.fill =  GridBagConstraints.HORIZONTAL;
      jPanel1.add(jTextField3, c8);

      // For the label "date"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel9, c2);

      // For date text field
      GridBagConstraints c9 = new GridBagConstraints();
      c9.gridwidth =  GridBagConstraints.REMAINDER;
      c9.fill =  GridBagConstraints.HORIZONTAL;
      jPanel1.add(jTextField4, c9);

      // For the label "para"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel10, c2);

      // For para text field
      GridBagConstraints c10 = new GridBagConstraints();
      c10.gridwidth =  GridBagConstraints.REMAINDER;
      c10.fill =  GridBagConstraints.HORIZONTAL;
      jPanel1.add(jTextField5, c10);

      // For "Query compose" button
      GridBagConstraints c3 = new GridBagConstraints();
      c3.gridwidth = GridBagConstraints.REMAINDER;
      c3.anchor = GridBagConstraints.NORTHWEST;
      jPanel1.add(jButton2, c3);

      // For the label "result query"
      c2.gridwidth = GridBagConstraints.RELATIVE;
      jPanel1.add(jLabel12, c2);

      // For result query text field
      GridBagConstraints c11 = new GridBagConstraints();
      c11.fill =  GridBagConstraints.HORIZONTAL;
      c11.gridwidth = GridBagConstraints.REMAINDER;
      jPanel1.add(jTextField6, c11);

      // For submit button
      GridBagConstraints c4 = new GridBagConstraints();
      c4.gridwidth = GridBagConstraints.REMAINDER;
      c4.anchor = GridBagConstraints.NORTHWEST;
      // c4.fill =  GridBagConstraints.NONE;
      jPanel1.add(jButton1, c4);

      // For null label
      c2.gridwidth = GridBagConstraints.REMAINDER;
      jPanel1.add(jLabel2, c2);

      //  for the label that informs how many elements are retrieved
      c2.gridwidth = GridBagConstraints.REMAINDER;
      jPanel1.add(jLabel3, c2);

      GridBagConstraints c5 = new GridBagConstraints();
      c5.fill = GridBagConstraints.BOTH;
      c5.gridwidth = 2;
      c5.weighty = 0.1;
      c5.weightx = 0.1;
      c5.insets = new Insets(3,3,3,3);
      jPanel1.add(scrollPane, c5);
      scrollPane.getViewport().add(jList1, null);

    JViewport jview = scrollPane.getViewport();
    jview.add(jList1);
    // ScrollPane.add(jList1);
    jComboBox1.setEditable( true ); // Make it Editable
    jList1.addMouseListener(mouseListener);
    /*
     * XPERT initialization
     */
    xr = new Xretrieve();
    // Change the name of directory where the nasa data is located!!!
    xr.initialize("\\shin\\xmlfiles\\nasa\\adcorg");
    try {
      dos = new DataOutputStream( new FileOutputStream("result.xml"));
    }
    catch(Exception e) {System.out.println("Exception = " + e);}

  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    Frame2_AboutBox dlg = new Frame2_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void jTextField1_actionPerformed(ActionEvent e) {
    try {
      String query = (String) jComboBox1.getSelectedItem();
      System.out.println("query = " + query);
      jComboBox1.addItem(query);
      jLabel2.setText("Processing the query...");
      result = xr.evaluate(query);

      int i = 0;
      System.out.println("result size = " + result.size());

    listContent.removeAllElements();
    // Add the elements to the list box in the order of retrieval
     while(i < result.size()) {
      ElementInfo ei = (ElementInfo) result.elementAt(i);
      String headString = xr.getElementHead(ei, 70);
      String eachLine = new String(String.valueOf(ei.score) +  "       " + headString);
      listContent.addElement(eachLine);
      i++;
     }
    }
    catch(com.futurexpert.xpert.xutility.XQueryException err) {System.out.println(err);}
    catch(Exception err) {System.out.println(err);}
  }

  // When the submit button for XPath query is pressed
  void jButton4_actionPerformed(ActionEvent e) {
    try {
      String query = (String) jComboBox1.getSelectedItem();
      System.out.println("query = " + query);
      jComboBox1.addItem(query);
      jLabel2.setText("Processing the query...");
      result = xr.evaluate(query);
      int i = 0;

      jList1.setAutoscrolls(true);
      String labeltext = new String(String.valueOf(result.size())+ " elements retrieved...");
      jLabel2.setText(labeltext);
      listContent.removeAllElements();
      // Add the head information of the retrieved elements to the list
      while(i < result.size()) {
      ElementInfo ei = (ElementInfo) result.elementAt(i);
      String headString = xr.getElementHead(ei, 100);
      String eachLine = new String(String.valueOf(ei.score) +  "     " + headString);
      listContent.addElement(eachLine);
      i++;
     }
    }
    catch(com.futurexpert.xpert.xutility.XQueryException err) {System.out.println(err);}
    catch(Exception err) {System.out.println(err);}
  }

  // When the button for query compose is pressed
  void jButton2_actionPerformed(ActionEvent e) {
    String titleS = null;
    String authorS = null;
    String keywordS = null;
    String yearS = null;
    String paraS = null;

    System.out.println("title = $" + jTextField1.getText()+"$");
    System.out.println("author = " + jTextField2.getText());
    System.out.println("keyword = " + jTextField3.getText());
    System.out.println("year = $" + jTextField4.getText()+"$");
    System.out.println("para = $" + jTextField5.getText()+"$");
    if(includeText(jTextField1.getText()) == true)
      titleS = new String("contains(.//title,\"" + jTextField1.getText() + "\")");
    if(includeText(jTextField2.getText()) == true)
      authorS = new String("contains(.//author,\"" + jTextField2.getText() + "\")");
    if(includeText(jTextField3.getText()) == true)
      keywordS = new String("contains(.//keyword,\"" + jTextField3.getText() + "\")");
    if(includeText(jTextField4.getText()) == true)
      yearS = new String("contains(.//year,\"" + jTextField4.getText() + "\")");
    if(includeText(jTextField5.getText()) == true)
      paraS = new String("contains(.//para,\"" + jTextField5.getText() + "\")");

    // Build the XPath query from the form-based input
    // The result should be '/dataset' that corresponds to the whole document
    StringBuffer queryBuffer = new StringBuffer(1000);
    boolean conditionAppended = false;
    queryBuffer.append("/dataset[");
    if(titleS != null) {
      queryBuffer.append(titleS);
      conditionAppended = true;
    }
    if(authorS != null) {
      if(conditionAppended == true)
        queryBuffer.append(" and ");
      queryBuffer.append(authorS);
      conditionAppended = true;
    }
    if(keywordS != null) {
      if(conditionAppended == true)
        queryBuffer.append(" and ");
      queryBuffer.append(keywordS);
      conditionAppended = true;
    }
    if(yearS != null) {
      if(conditionAppended == true)
        queryBuffer.append(" and ");
      queryBuffer.append(yearS);
      conditionAppended = true;
    }
    if(paraS != null) {
      if(conditionAppended == true)
        queryBuffer.append(" and ");
      queryBuffer.append(paraS);
      // queryBuffer.append("]");
    }
    if((titleS != null) || (authorS != null) || (keywordS != null)
        || (yearS != null) || (paraS != null))
      queryBuffer.append("]");
    String XpathQuery = queryBuffer.toString();
    System.out.println("Final query = " + XpathQuery);
    jTextField6.setText(XpathQuery);
  }

  // When the submit button for the composed query is pressed
  void jButton1_actionPerformed(ActionEvent e) {
      try {
      String query = jTextField6.getText();
      result = xr.evaluate(query);
      System.out.println("query = " + query);
      jComboBox1.addItem(query);
      jLabel2.setText("Processing the query...");
      result = xr.evaluate(query);
      int i = 0;

      jList1.setAutoscrolls(true);
      String labeltext = new String(String.valueOf(result.size())+ " elements retrieved...");
      jLabel2.setText(labeltext);

      listContent.removeAllElements();
      // Add the retrieved element to the list in the order of the retrieval
      while(i < result.size()) {
      ElementInfo ei = (ElementInfo) result.elementAt(i);
      String headString = xr.getElementHead(ei, 100);
      String eachLine = new String(String.valueOf(ei.score) +  "     " + headString);
      listContent.addElement(eachLine);
      i++;
     }
    }
    catch(com.futurexpert.xpert.xutility.XQueryException err) {System.out.println(err);}
    catch(Exception err) {System.out.println(err);}
  }

    /**
   * Check if the input string has a text other than white string
   */
  boolean includeText(String text) {
	int i = 0;
	int length = text.length();
	char c;
	if(length == 0)
		return false;
	c = text.charAt(i);
	while(c == '\n' || c == '\t' || c == ' ' || c =='\r' || c == '\f' || c == '\b') {
		if((i >= length -1) || (text.charAt(i) == '\0'))
			return false;
		i++;
		c = text.charAt(i);
	}
	return true;
    }
}


class Frame2_jButton4_actionAdapter implements java.awt.event.ActionListener {
  Frame2 adaptee;

  Frame2_jButton4_actionAdapter(Frame2 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton4_actionPerformed(e);
  }
}

class Frame2_jButton1_actionAdapter implements java.awt.event.ActionListener {
  Frame2 adaptee;

  Frame2_jButton1_actionAdapter(Frame2 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class Frame2_jButton2_actionAdapter implements java.awt.event.ActionListener {
  Frame2 adaptee;

  Frame2_jButton2_actionAdapter(Frame2 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}
