import java.io.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import com.futurexpert.xpert.xretrieve.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * October 2000
 * ADC Servlet
 *
 */

public class ADCServlet extends HttpServlet {

    // ADCcoll represents the directory or meta-file that contains collection
    private static String ADCcoll = "/home/dwshin/XML/nasa/adcorg/adc1500";
    Xretrieve xr = null;
    static ServletContext context = null;
    String query = null;

    /**
     * Initialize servlet.
     * Read config variables
     */

    public void init(ServletConfig config) throws ServletException {
         context = config.getServletContext();
        try {
    	    xr = new Xretrieve();
            xr.initialize(ADCcoll);
        } catch (Exception e) {
		/* PrintWriter out;
		// set content type and other response header fields first
		response.setContentType("text/html");
		out = response.getWriter();
		out.println("<HTML>\n");
		out.println("<BODY>\n <B> Initialization error in servlet </B> \n");
		out.println("</BODY> \n </HTML>\n"); */
             context.log(e, "Error initializing servlet");
        }        
    }

    /**
     * The method performing the search, handling input from the user 
     */


    public void doGet (HttpServletRequest request,
                       HttpServletResponse response)
        throws ServletException, IOException
    {
	// if(request.getParameter("Submit") != null)
            query = (String)request.getParameter("search");


        PrintWriter out;
        // set content type and other response header fields first
        response.setContentType("text/html");
        // then write the data of the response
        out = response.getWriter();
            try {
                Vector result = xr.evaluate(query);
                int i = 0;
                out.println("<HTML>\n");
		out.println("<HEAD><TITLE>XML Output</TITLE></HEAD>\n");
                out.println("<BODY>\n");
		out.println("<H2>XML Output</H2>\n");
		out.println("XML query = ");
		out.println(query);
		out.println("<BR><H3>Number retrieved : </H3>");
		out.println(String.valueOf(result.size()));
		out.println("<BR><BR>\n\n");
		// out.println("<?xml version=\"1.0\" ?>");
                // out.println("<xmlout>\n");
                while(i < result.size()) {
                    ElementInfo ei = (ElementInfo) result.elementAt(i);
                    String content = xr.getElement(ei);
                    out.println("<B>Result</B><BR>");
                    // out.println("<score>");
                    out.println("<B>score</B><BR>");
                    out.println(String.valueOf(ei.score));
                    out.println("<BR>");
                    // out.println("</score>\n");
                    // out.println("<BR><B>score</B><BR>");
                    out.println(content);
                    // out.println("</result>\n");
                    out.println("<BR><HR><BR>");
                    i++;
                }
                // out.println("</xmlout>\n");
                out.println("</BODY>\n");
                out.println("</HTML>\n");
            // } catch (com.futurexpert.xpert.xutility.XQueryException xe) {
             //    context.log(xe, "Error during query");
            } catch (Exception e) {
                context.log(e, "Error during query");
            }
        out.close();
    }

    /**
     * Reroute to doGet
     */

    public void doPost (HttpServletRequest request,
                        HttpServletResponse response)
        throws ServletException, IOException
    {
        doGet(request, response);
    }
}
